import pygame, sys, time, random
from pygame.locals import *

# set up pygame
pygame.init()
mainClock = pygame.time.Clock()

# set up the window
WINDOWWIDTH = 800
WINDOWHEIGHT = 800
windowSurface = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT), 0, 32)
pygame.display.set_caption('Digital Girl')

# set up the colors
ALICEBLU = (255,228,225)
BLACK = (0, 0, 0)

r1 = pygame.image.load ('ragazza1.png')
r2 = pygame.image.load ('ragazza2.png')
r3 = pygame.image.load ('ragazza3.png')


# set up the block data structure
player = pygame.Rect(300, 100, 75, 100)
# playerImage = pygame.image.load("ragazza1.png")
#playerImage = pygame.image.load(random.choice(['ragazza1.png', 'ragazza2.png', 'ragazza3.png']) )
playerImage = pygame.image.load(random.choice(['ragazza'+str(i)+'.png' for i in range(1, 4)]) )
playerStretchedImage = pygame.transform.scale(playerImage, (75, 150))
foodImage = pygame.image.load('dvd.png')
foods = []
for i in range(20):
    foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - 20), random.randint(0, WINDOWHEIGHT - 20), 50, 50))

foodCounter = 0
NEWFOOD = 40

# set up keyboard variables

punteggio = 0
moveLeft = False
moveRight = False
moveUp = False
moveDown = False

MOVESPEED = 9

DOWNLEFT = 1
DOWNRIGHT = 3
UPLEFT = 7
UPRIGHT = 9

MOVESPEEDvirus = 4



# set up music
pickUpSound = pygame.mixer.Sound('pickup.wav')
pygame.mixer.music.load('background.wav')
pygame.mixer.music.play(-1, 0.0)
musicPlaying = True


viruses = []
for i in range(1,5):
    viruses.append({'rect': pygame.Rect(random.randint(0, WINDOWWIDTH - 100), random.randint(0, WINDOWHEIGHT - 100), 100, 100), 'image':pygame.image.load('virus'+str(i)+'.png'), 'dir':UPRIGHT })

colpito_dal_virus = False
tempo_immunità = 0
TEMPO_MASSIMO_IMMUNITÀ = 50

def prontoACominciare():
    sfondo = pygame.image.load('sfondoIniziale.png')
    freccia = pygame.image.load('freccia.png')
    windowSurface.blit(sfondo, (0, 0))
    rect = pygame.Rect(windowSurface.get_rect().width - freccia.get_rect().width , 0, freccia.get_rect().width,freccia.get_rect().height )
    windowSurface.blit(freccia, rect)
    pygame.display.update()
    while True:
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
            if event.type == MOUSEBUTTONUP:
                if rect.collidepoint(event.pos):
                    return




prontoACominciare()

# run the game loop
while True:

    pygame.display.set_caption('Punteggio : '+ str(punteggio))
    # check for the QUIT event
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        if event.type == KEYDOWN:
            # change the keyboard variables
            if event.key == K_LEFT or event.key == ord('a'):
                moveRight = False
                moveLeft = True
            if event.key == K_RIGHT or event.key == ord('d'):
                moveLeft = False
                moveRight = True
            if event.key == K_UP or event.key == ord('w'):
                moveDown = False
                moveUp = True
            if event.key == K_DOWN or event.key == ord('s'):
                moveUp = False
                moveDown = True
        if event.type == KEYUP:
            if event.key == K_ESCAPE:
                pygame.quit()
                sys.exit()
            if event.key == K_LEFT or event.key == ord('a'):
                moveLeft = False
            if event.key == K_RIGHT or event.key == ord('d'):
                moveRight = False
            if event.key == K_UP or event.key == ord('w'):
                moveUp = False
            if event.key == K_DOWN or event.key == ord('s'):
                moveDown = False
            if event.key == ord('x'):
                player.top = random.randint(0, WINDOWHEIGHT - player.height)
                player.left = random.randint(0, WINDOWWIDTH - player.width)
            if event.key == ord('m'):
                if musicPlaying:
                    pygame.mixer.music.stop()
                else:
                    pygame.mixer.music.play(-1, 0.0)
                musicPlaying = not musicPlaying

        if event.type == MOUSEBUTTONUP:
            foods.append(pygame.Rect(event.pos[0] - 10, event.pos[1] - 10, 20, 20))

    foodCounter += 1
    if foodCounter >= NEWFOOD:
        # add new food
        foodCounter = 0
        foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - 20), random.randint(0, WINDOWHEIGHT - 20), 20, 20))

    # draw the black background onto the surface
    windowSurface.fill(ALICEBLU)

    # move the player
    if moveDown and player.bottom < WINDOWHEIGHT:
        player.top += MOVESPEED
    if moveUp and player.top > 0:
        player.top -= MOVESPEED
    if moveLeft and player.left > 0:
        player.left -= MOVESPEED
    if moveRight and player.right < WINDOWWIDTH:
        player.right += MOVESPEED

    #Movimento virus

    for virus in viruses:
        # move the block data structure
        if virus['dir'] == DOWNLEFT:
            virus['rect'].left -= MOVESPEEDvirus
            virus['rect'].top += MOVESPEEDvirus
        if virus['dir'] == DOWNRIGHT:
            virus['rect'].left += MOVESPEEDvirus
            virus['rect'].top += MOVESPEEDvirus
        if virus['dir'] == UPLEFT:
            virus['rect'].left -= MOVESPEEDvirus
            virus['rect'].top -= MOVESPEEDvirus
        if virus['dir'] == UPRIGHT:
            virus['rect'].left += MOVESPEEDvirus
            virus['rect'].top -= MOVESPEEDvirus

        # check if the block has move out of the window
        if virus['rect'].top < 0:
            # block has moved past the top
            if virus['dir'] == UPLEFT:
                virus['dir'] = DOWNLEFT
            if virus['dir'] == UPRIGHT:
                virus['dir'] = DOWNRIGHT
        if virus['rect'].bottom > WINDOWHEIGHT:

            # block has moved past the bottom
            if virus['dir'] == DOWNLEFT:
                virus['dir'] = UPLEFT
            if virus['dir'] == DOWNRIGHT:
                virus['dir'] = UPRIGHT
        if virus['rect'].left < 0:
            # block has moved past the left side
            if virus['dir'] == DOWNLEFT:
                virus['dir'] = DOWNRIGHT
            if virus['dir'] == UPLEFT:
                virus['dir'] = UPRIGHT
        if virus['rect'].right > WINDOWWIDTH:
            # block has moved past the right side
            if virus['dir'] == DOWNRIGHT:
                virus['dir'] = DOWNLEFT
            if virus['dir'] == UPRIGHT:
                virus['dir'] = UPLEFT


    # draw the block onto the surface
    windowSurface.blit(playerStretchedImage, player)

    # check if the block has intersected with any food squares.
    for food in foods[:]:
        if player.colliderect(food):
            foods.remove(food)
            punteggio = punteggio + 1
            #player = pygame.Rect(player.left, player.top, player.width + 1, player.height + 1)
            #playerStretchedImage = pygame.transform.scale(playerImage, (player.width, player.height))
            if musicPlaying:
                pickUpSound.play()

    #Controllo virus
    if not colpito_dal_virus:
        for virus in viruses:
            if player.colliderect( virus['rect']):
                punteggio = punteggio - 5
                colpito_dal_virus = True
                tempo_immunità = 0
    else:
        if tempo_immunità < TEMPO_MASSIMO_IMMUNITÀ:
            tempo_immunità += 1
        else:
            colpito_dal_virus = False
            tempo_immunità = 0


    # draw the food
    for food in foods:
        windowSurface.blit(foodImage, food)

    #draw the virus
    for virus in viruses:
        windowSurface.blit(virus['image'], virus['rect'] )

    # draw the window onto the screen
    pygame.display.update()
    mainClock.tick(40)
